<template>
  <div class="container-mid">
    <h3>Register</h3>
    <form class="mb-5">
      <div class="form-group">
        <label>Username</label>
        <input
          type="text"
          class="form-control"
          :value="user.username.toLowerCase()"
          @input="user.username = $event.target.value.toLowerCase()"
        />
        <small class="text-muted">
          This name will be displayed on your profile.
          <a
            tabindex="-1"
            href="/more"
            @click.prevent="showUsernameRules = true"
          >Learn more</a>
        </small>
      </div>
      <div class="form-group">
        <label>Email (optional)</label>
        <input
          type="text"
          class="form-control"
          :value="user.email.toLowerCase()"
          @input="user.email = $event.target.value.toLowerCase()"
        />
        <small class="text-muted">If you ever forget your password, we can send a new one via email.</small>
      </div>
      <div class="form-group">
        <label>Password</label>
        <input :type="passwordInputType" class="form-control" v-model="user.password" />
      </div>
      <div class="form-group">
        <label>Password confirmation</label>
        <input :type="passwordInputType" class="form-control" v-model="passwordConfirmation" />
      </div>

      <div class="d-flex">
        <button
          type="button"
          class="btn btn-outline-secondary mr-auto"
          @click="showPasswords = !showPasswords"
        >{{passwordShowHideText}}</button>
        <button type="button" class="btn btn-outline-primary mr-2">Cancel</button>
        <button type="submit" class="btn btn-primary" @click.prevent="submit">Sign up</button>
      </div>
    </form>
    <app-feedback v-if="status" @closed="status = ''">{{status}}</app-feedback>
    <app-username-rules v-if="showUsernameRules" class="mt-2" @closed="showUsernameRules = false" />
    <div class="text-center text-muted mt-5">
      Already have an account?
      <router-link to="/auth/login">Go to login</router-link>.
    </div>
  </div>
</template>

<script>
import { isValidUsername } from "@/utils/";
import appUsernameRules from "./UsernameRules.vue";

export default {
  data() {
    return {
      status: "",
      passwordConfirmation: "",
      showPasswords: false,
      showUsernameRules: false,
      user: {
        username: "",
        password: "",
        email: ""
      }
    };
  },
  computed: {
    passwordInputType() {
      return this.showPasswords ? "text" : "password";
    },
    passwordShowHideText() {
      return this.showPasswords ? "Hide passwords" : "Show passwords";
    },
    mode() {
      return this.$route.name == "auth-register" ? "register" : "login";
    }
  },
  methods: {
    async submit() {
      console.log("submitting");

      if (this.user.username == "") {
        this.status = "Username must not be empty.";
        return;
      }

      if (!isValidUsername(this.user.username)) {
        this.status = "Invalid username";
        this.showUsernameRules = true;
        return;
      }

      if (this.user.password == "") {
        this.status = "Password must not be empty.";
        return;
      }

      if (this.user.password != this.passwordConfirmation) {
        this.status = "Passwords do not match.";
        return;
      }

      try {
        //await api.post("/auth/register", this.user);
        await this.$store.dispatch("auth/login", {
          url: "/auth/register",
          user: this.user
        });
        this.$router.push("/surveys");
      } catch (error) {
        switch (error.response.status) {
          case 409:
            this.status = error.response.data;
            break;
          default:
            this.status = `Unknown error :/`;
        }
      }
    }
  },
  components: {
    appUsernameRules
  }
};
</script>